<template>
  <b-tab >
    <template #title>
      <b-icon icon="palette"></b-icon> Analyse thématique
    </template>

    <h3 class="line-header" v-if="!editRules">Analyse thématique</h3>
    <b-alert v-if="errorTxt !== null" show variant="warning" dismissible>{{errorTxt}}</b-alert>
    <b-row v-if="layer.isWMS()" class="mb-3">
        <b-col cols="6">
        <b-checkbox
          v-model="layer.useSldBody" switch>
          Utiliser le style défini ici pour les requêtes WMS.<br>
          <i class="text-danger">Attention ceci va surcharger le style du serveur
              en utilisant le paramètre SLD_BODY</i>
        </b-checkbox>
        </b-col>
      <b-col cols="6">
        <b-alert variant="info" show dismissible v-if="geometryTypeNotDefined" class="text-center">
          Attention le type de géométrie n'est pas défini, merci de le préciser<br/><br/>
          <b-select v-model="layer.geometryType" :options="geometryTypeList" class="w-50"></b-select>
        </b-alert>
      </b-col>
    </b-row>
    <b-row>
      <b-col  cols="12">
        <b-button style="margin-left:5px" v-if="!newAnalyse  && !editRules"
          class="bg_color-second" @click="newAnalyse=true">
            <b-icon icon="plus-square"></b-icon>&nbsp;Nouvelle Analyse</b-button>
        <b-button style="margin-left:5px" v-if="layer.hasRules() && !editRules"
          class="bg_color-second" @click="editRules=true">
            <b-icon icon="pencil-square"></b-icon>&nbsp;Editer les règles</b-button>
      </b-col>
    </b-row>
    <b-row>
      <b-col  cols="12" md="6" v-if="newAnalyse">
        Choisir un attribut:
        <v-select :options="layer.layerProperties" label="name"
          v-model="attribute"
          @input="changeAttribute()"
          :clearable="false">
          <template v-slot:option="option">
                {{ option.name }}
          </template>
        </v-select>
      </b-col>
    </b-row>
    <b-row v-if="attribute!=null && newAnalyse">
      <b-col  cols="6" md="6">
         Choisir une palette de couleur: <br>
         <v-select :options="colorPalettes" label="name"
          v-model="colorPalette"
          :clearable="false">
          <template v-slot:option="option">
             <ColorPalettePanel
              :colorPalette="getColorPalette(option)" :nbColors="nbColors"/>
                {{ option.name }}
          </template>
        </v-select>
        Ou : <br>
        <b-checkbox
          v-model="modePointSize" switch @change="changeMode()">
          Faire varier la taille des points
        </b-checkbox>
      </b-col>
      <b-col  cols="6" md="6">
          <FormNumberInput v-bind:label="'Nombre de couleurs distinctes'"
              v-model="nbColors"/>
      </b-col>
    </b-row>
    <template v-if="numberAttributeSelected() && newAnalyse">
        <b-row >
          <b-col  cols="12" md="6">
            <b-form-group label="Type d'analyse"
              class="mb-0"
              label-cols-sm="3"
              label-align-sm="right"
              v-slot="{ ariaDescribedby }">
              <b-form-radio-group
                class="pt-2"
                v-model="analyseType"
                :options="analyseTypes"
                :aria-describedby="ariaDescribedby"
                name="radio-inline"
              ></b-form-radio-group>
            </b-form-group>
        </b-col>
      </b-row>
    </template>

    <template v-if="(colorPalette!=null || modePointSize) && newAnalyse && analyseType === 'categorized'">
      <b-row >
        <b-col  cols="12" md="6">
          <FormTextInput v-bind:label="'Liste des valeurs distinctes'"
              v-model="valueList" :placeholder="'jaune, vert, bleue'"/>
        </b-col>
      </b-row>
      <b-row >
        <b-col cols="12">
          <b-button style="margin-left:5px"
            class="bg_color-second" @click="addRulesFromList()">
              générer les règles de rendu à partir d'une liste</b-button>
              Ou
          <b-button style="margin-left:5px"
            class="bg_color-second" @click="addRulesFromDatas()">
              générer les règles de rendu à partir des données</b-button>
        </b-col>
      </b-row>
    </template>
    <template v-if="(colorPalette!=null || modePointSize) && newAnalyse && analyseType === 'graduated'">
      <b-row >
        <b-col v-if="modePointSize" cols="4" md="6">
          <FormNumberInput v-bind:label="'Taille Min des points'"
              v-model="minPointSize"/>
        </b-col>
        <b-col v-if="modePointSize" cols="4" md="6">
          <FormNumberInput v-bind:label="'Taille Max des points'"
              v-model="maxPointSize"/>
        </b-col>
        <b-col  cols="4" md="6">
          <FormNumberInput v-bind:label="'Valeur Min'"
              v-model="minValue"/>
        </b-col>
        <b-col  cols="4" md="6">
          <FormNumberInput v-bind:label="'Valeur Max'"
              v-model="maxValue"/>
        </b-col>
        <b-col  cols="4" md="6">
          <FormNumberInput v-bind:label="'Nombre de classes'"
              v-model="nbClasses"/>
        </b-col>
        <b-col  cols="4" md="6">
          <FormComboInput :label="'Mode'" v-model="graduatedMode" :options="graduatedModes"/>
        </b-col>

      </b-row>
      <b-row >
        <b-col cols="12">
          <b-button style="margin-left:5px"
            :disabled="isNaN(minValue) || isNaN(maxValue) || isNaN(nbClasses)"
            class="bg_color-second" @click="addGraduatedRules()">
              générer les règles</b-button>
        </b-col>
      </b-row>
    </template>
    <b-alert :show="showMsgExistingRules" variant="success">La liste des règles n'est pas vide,
      Voulez vous ajouter les nouvelles classes à la suite ou remplacer les règles existantes
      <b-button style="margin-left:5px"
            class="bg_color-second" @click="addRules()">
              Ajouter</b-button>
      <b-button style="margin-left:5px"
            class="bg_color-second" @click="replaceRules()">
              Remplacer</b-button>
    </b-alert>
    <h3 class="line-header" v-if="hasRules()">Liste des Régles Actuelles</h3>
      <template v-if="editRules">
        <b-button style="margin-left:5px"
          class="bg_color-second" @click="deleteRules()">
            <b-icon icon="trash"></b-icon>&nbsp;<span v-if="selectedRules.length>0">Supprimer la sélection</span>
            <span v-else>Supprimer Toutes les Règles</span>
        </b-button>
        <b-button style="margin-left:5px"
          class="bg_color-second" @click="addRule()">
            <b-icon icon="plus-square"></b-icon>&nbsp;Ajouter une règle</b-button>
        <b-button style="margin-left:5px"
          class="bg_color-second" @click="endEdition()">
            <b-icon icon="check2-square"></b-icon>&nbsp;Terminer l'édition
        </b-button>
      </template>
    <b-row v-if="hasRules()" class="m-2 rule-list">
      <b-col  cols="12">
        <template v-for="rule in this.complexStyle.styleRules">
          <b-row :key="rule.id" class="rule_row">
            <b-col v-if="editRules" cols="1">
              <b-form-checkbox v-model="rule.checked" switch></b-form-checkbox>
            </b-col>
            <b-col  cols="2" v-if="editRules">
              <FormTextInput v-bind:label="''" :labelcols="0" :cols="12" :md="12"
              v-model="rule.label"/>
            </b-col>
            <b-col  cols="2" v-else>
              {{rule.label}}
            </b-col>
            <b-col  cols="4" v-if="editRules">
              <FormTextInput v-bind:label="''" :labelcols="0" :cols="12" :md="12"
              v-model="rule.value"/>
            </b-col>
            <b-col  cols="2" v-else>
              {{rule.value}}
            </b-col>
            <b-col  cols="1">
              <VectorLegend :layer="layer" :rule="rule" :refreshToken="refreshToken"/>
            </b-col>
            <b-col  cols="1" v-if="editRules">
              <button class="btn btn-sm p-0"  style="margin-right:6px;"
                  @click="rule.styleEdit=!rule.styleEdit"
                  v-b-tooltip.hover title="éditer le style de la règle">
                  <b-icon
                    :icon="rule.styleEdit ? 'pencil-fill':'pencil'"
                    variant="primary"></b-icon> &nbsp;
              </button>
              <button class="btn btn-sm p-0"  style="margin-right:6px;"
                  @click="removeRule(rule)" v-b-tooltip.hover title="Supprimer la règle">
                  <b-icon icon="trash" variant="primary"></b-icon> &nbsp;
              </button>
            </b-col>
          </b-row>
          <b-collapse :key="rule.id"
              cols="12" v-if="editRules && rule.styleEdit" :appear="true"
              :visible="editRules && rule.styleEdit">
              <SingleStyleDefinition :layer="layer" :styleDefinition="rule.style" @symboChange="symboChange()"/>
            </b-collapse>
        </template>
      </b-col>
    </b-row>
  </b-tab>
</template>

<script lang="ts">
/* eslint-disable no-param-reassign */
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
/*  eslint-disable prefer-destructuring */
import FormTextInput from '@/components/shared/FormTextInput.vue';
import LayerConfig from '@/models/map-context/LayerConfig';
import PointStyleDefinition from '@/components/layers/style/PointStyleDefinition.vue';
import FillStyleDefinition from '@/components/layers/style/FillStyleDefinition.vue';
import StrokeStyleDefinition from '@/components/layers/style/StrokeStyleDefinition.vue';
import TextStyleDefinition from '@/components/layers/style/TextStyleDefinition.vue';
import Component from 'vue-class-component';
import chroma from 'chroma-js';
import geostats from 'geostats';
import LayerStyle from '@/models/map-context/LayerStyle';
import StyleRule from '@/models/map-context/style/StyleRule';
import LayerStyleComplex from '@/models/map-context/LayerStyleComplex';
import ColorPalette, { IColorPalette } from '@/models/ColorPalette';
import VectorLegend from '@/components/plugins/legend/VectorLegend.vue';
import ColorPalettePanel from '@/components/shared/ColorPalettePanel.vue';
import FormNumberInput from '@/components/shared/FormNumberInput.vue';
import LayerAttribute from '@/models/map-context/LayerAttribute';
import FormComboInput from '@/components/shared/FormComboInput.vue';
import axios, { AxiosResponse } from 'axios';
import { GeoJSON } from 'ol/format';
import {
  Observable, of, pipe, from,
} from 'rxjs';
import {
  catchError,
  map, filter, distinct,
} from 'rxjs/operators';
import GeometryType from '@/models/map-context/GeometryType';
import BaseComponent from '../../BaseComponent';
import SingleStyleDefinition from '../style/SingleStyleDefinition.vue';

@Component({
  props: {
    layer: LayerConfig,
  },
  components: {
    FormTextInput,
    FormNumberInput,
    FormComboInput,
    PointStyleDefinition,
    FillStyleDefinition,
    StrokeStyleDefinition,
    TextStyleDefinition,
    VectorLegend,
    SingleStyleDefinition,
    ColorPalettePanel,
  },
})
export default class SingleLayerComplexStyle extends BaseComponent {
  layer!: LayerConfig;

  newAnalyse = false;

  editRules = false;

  analyseType= 'categorized';

  refreshToken = 0;

  modePointSize = false;

  minPointSize = 3;

  maxPointSize = 50;

  analyseTypes= [
    { text: 'Catégorisé', value: 'categorized' },
    { text: 'Gradué', value: 'graduated' },
  ];

  graduatedModes = [
    // { text: 'Nombre égal (Quantile )', value: 'quantile' },
    { text: 'Nombre égal (Quantile)', value: 'quantile_geostats' },
    { text: 'Ecart Type', value: 'stddev_geostats' },
    { text: 'Ruptures naturelles (jenks)', value: 'jenks' },
    { text: 'Echelle logarithmique', value: 'logaritmic' },
    { text: 'Progression arithmétique', value: 'arithmeticProgression_geostats' },
    { text: 'Progression géométrique', value: 'geometricProgression_geostats' },
    { text: 'Intervalle égal', value: 'equalInterval' },
    // { text: 'Intervalle égal (Geostat)', value: 'equalInterval_geostats' },
  ];

  graduatedMode = 'quantile_geostats';

  attribute:LayerAttribute|null=null;

  colorPalette:ColorPalette|null=null;

  colorPalettes:ColorPalette[]=[];

  errorTxt:string|null=null;

  valueList:string|null=null;

  complexStyle=new LayerStyleComplex();

  showMsgExistingRules = false;

  valuesToAdd:Array<any>=[];

  nbColors=10;

  minValue=0;

  maxValue=0;

  nbClasses=5;

  geometryTypeList = [GeometryType.UNDEFINED,
    GeometryType.LINE, GeometryType.POINT, GeometryType.POLYGON];

  mounted() {
    this.colorPalettes = this.contextService.colorPalettes;
    console.log(this.colorPalettes);
    if (this.layer.complexStyle) {
      this.complexStyle = this.layer.complexStyle;
    }
    if (!this.layer.hasRules()) {
      this.newAnalyse = true;
    }
  }

  hasRules():boolean {
    return this.layer.hasRules();
  }

  get geometryTypeNotDefined():boolean {
    return this.layer.geometryType === undefined
    || this.layer.geometryType === GeometryType.UNDEFINED;
  }

  changeMode() {
    if (this.modePointSize) {
      this.analyseType = 'graduated';
    }
  }

  getColorPalette(x:any) {
    return new ColorPalette(x);
  }

  symboChange() {
    this.refreshToken += 1;
  }

  addRule() {
    const style = new LayerStyle();
    style.setBaseStyle(this.layer.style);
    const color:any = 'rgb(0,255,0)';
    style.applyRuleColor(color);
    const filter = `attribute='value_${this.layer.complexStyle.styleRules.length}'`;
    const newRule = new StyleRule({ label: 'newRule', value: filter, style });
    newRule.style = style;
    if (this.layer.complexStyle.styleRules.find((x) => x.value === filter) === undefined) {
      this.layer.complexStyle.styleRules.push(newRule);
    }
  }

  endEdition() {
    this.editRules = false;
  }

  removeRule(rule:StyleRule) {
    const ruleIndex = this.layer.complexStyle.styleRules.indexOf(rule);
    this.layer.complexStyle.styleRules.splice(ruleIndex, 1);
  }

  deleteRules() {
    if (this.selectedRules.length > 0) {
      // on filtre pour ne récupérer que ceux qui ne sont pas sélectionnés
      const newList:StyleRule[] = [];
      this.layer.complexStyle.styleRules.forEach((x) => {
        if (this.selectedRules.indexOf(x) < 0) {
          newList.push(x);
        }
      });
      // .filter((x) => this.selectedRules.indexOf(x) < 0);
      this.layer.complexStyle.styleRules = newList;
    } else {
      this.layer.complexStyle.styleRules = [];
      this.editRules = false;
    }
  }

  get selectedRules():StyleRule[] {
    let selected:StyleRule[] = [];
    if (this.layer.complexStyle && this.layer.complexStyle.styleRules) {
      selected = this.layer.complexStyle.styleRules.filter((x) => x.checked);
    }

    return selected;
  }

  addGraduatedRules() {
    this.newAnalyse = false;
    const plageValues = this.maxValue - this.minValue;
    const equalinterval = plageValues / this.nbClasses;
    const quantilesInterval = 1 / this.nbClasses;
    this.getValues().subscribe((values) => {
      const graduatedRule = [];
      let res = [];
      if (this.graduatedMode === 'logaritmic') {
        values = values.map((x) => Math.log(x));
      }
      // eslint-disable-next-line new-cap
      const geo = new geostats(values);
      geo.setPrecision(6);
      if (this.graduatedMode === 'jenks') {
        res = geo.getClassJenks(this.nbClasses);
      } else if (this.graduatedMode === 'quantile_geostats') {
        res = geo.getClassQuantile(this.nbClasses);
      } else if (this.graduatedMode === 'stddev_geostats') {
        res = geo.getClassStdDeviation(this.nbClasses);
      } else if (this.graduatedMode === 'equalInterval_geostats') {
        res = geo.getClassEqInterval(this.nbClasses);
      } else if (this.graduatedMode === 'arithmeticProgression_geostats') {
        res = geo.getClassArithmeticProgression(this.nbClasses);
      } else if (this.graduatedMode === 'geometricProgression_geostats') {
        res = geo.getClassGeometricProgression(this.nbClasses);
      } else if (this.graduatedMode === 'logaritmic') {
        res = geo.getClassQuantile(this.nbClasses);
      }

      for (let index = 0; index < this.nbClasses; index += 1) {
        if (this.graduatedMode === 'quantile') {
          const minQuantile = Number(this.quantile(values, 0 + index * quantilesInterval).toFixed(2));
          const maxQuantile = Number(this.quantile(values, 0 + (index + 1) * quantilesInterval).toFixed(2));
          graduatedRule.push({
            min: minQuantile,
            max: maxQuantile,
          });
        } else if (this.graduatedMode === 'jenks'
          || this.graduatedMode === 'quantile_geostats'
          || this.graduatedMode === 'equalInterval_geostats'
          || this.graduatedMode === 'arithmeticProgression_geostats'
          || this.graduatedMode === 'geometricProgression_geostats'
          || this.graduatedMode === 'stddev_geostats') {
          graduatedRule.push({
            min: Number(res[index].toFixed(2)),
            max: Number(res[(index + 1)].toFixed(2)),
          });
        } else if (this.graduatedMode === 'logaritmic') {
          graduatedRule.push({
            min: Number(Math.exp(res[index]).toFixed(2)),
            max: Number(Math.exp(res[(index + 1)]).toFixed(2)),
          });
        } else {
          graduatedRule.push({
            min: Number((this.minValue + index * equalinterval).toFixed(2)),
            max: Number((this.minValue + (index + 1) * equalinterval).toFixed(2)),
          });
        }
      }
      this.valuesToAdd = graduatedRule;
      if (this.layer.complexStyle && this.layer.complexStyle.styleRules.length > 0) {
        this.showMsgExistingRules = true;
      } else {
        this.finalizeAddRulesForValues();
      }
    });
  }

  addRulesFromDatas() {
    this.errorTxt = 'Calculs en cours....';
    this.getDistinctValues().subscribe((values) => {
      this.errorTxt += `${values.length} valeurs distinctes trouvées...`;
      this.addRulesForValues(values);
      this.newAnalyse = false;
    });
  }

  addRules() {
    this.finalizeAddRulesForValues();
  }

  replaceRules() {
    this.layer.complexStyle.styleRules = [];
    this.finalizeAddRulesForValues();
  }

  addRulesFromList() {
    if (this.valueList === null || this.valueList?.length === 0) {
      this.errorTxt = 'Vous devez renseigner une liste valeurs séparées par des virgules';
    } else {
      this.addRulesForValues(this.valueList.split(','));
      this.newAnalyse = false;
    }
  }

  getMaxValue(values:number[]):number {
    const arrMax = (arr:any) => Math.max(...arr);
    return arrMax(values);
  }

  getMinValue(values:number[]):number {
    const arrMin = (arr:any) => Math.min(...arr);
    return arrMin(values);
  }

  quantile(arr:any, q:number) {
    const sorted = arr;
    const pos = (sorted.length - 1) * q;
    const base = Math.floor(pos);
    const rest = pos - base;
    if (sorted[base + 1] !== undefined) {
      return sorted[base] + rest * (sorted[base + 1] - sorted[base]);
    }
    return sorted[base];
  }

  /**
   * retourne la liste des valeurs des objets de la carte triée par ordre croissant
   * pour un attribut numérique
   */
  getValues():Observable<number[]> {
    const asc = (arr:any) => arr.sort((a:any, b:any) => a - b);
    return this.getDataValues().pipe(map((vals:any) => asc(vals.map((x:any) => Number(x)))));
  }

  /**
   * retourne la liste des valeurs des objets de la carte
   * pour un attribut numérique
   */
  getDataValues():Observable<any[]> {
    let values = [];

    if (this.layer.isWMS() && this.layer.hasWFSCapacity()) {
      const urlGetFeature = this.layer.wmsUrlToWfs(this.layer.getFeatureWFSUrl());
      const maxFeatures = this.layer.maxFeatures;
      const url = `${urlGetFeature
      }&maxfeatures=${maxFeatures
      }&count=${maxFeatures
      }&typenames=${this.layer.layername}`
        + `&typename=${this.layer.layername}&`
        + 'outputFormat=json&srsname=EPSG:3857';
      return from(axios.get(url)).pipe(
        map((reponse:any) => {
          const allFeatures = new GeoJSON().readFeatures(reponse.data);
          return allFeatures.map((x:any) => x.get(this.attribute?.name));
        }),
      );
    }
    if (this.layer.getLayerSource().getFeaturesInExtent) {
      const size = /** @type {ol.Size} */ (this.getOpenLayersMapService().map.getSize());
      const extent = this.getOpenLayersMapService().map.getView().calculateExtent(size);
      values = this.layer.getLayerSource()
        .getFeaturesInExtent(extent).map((x:any) => x.get(this.attribute?.name));
    } else {
      values = this.layer.getLayerSource().getFeatures()
        .map((x:any) => x.get(this.attribute?.name));
    }
    console.log(values);
    return of(values);
  }

  getDistinctValues():Observable<number[]> {
    return this.getDataValues().pipe(
      map((x:any) => x.filter((v:any, i:any, a:any) => a.indexOf(v) === i)),
    ); // to get distinct values)); // to get distinct values
  }

  changeAttribute() {
    console.log(this.attribute?.isNumber());
    this.getValues().subscribe((values) => {
      this.maxValue = this.getMaxValue(values);
      this.minValue = this.getMinValue(values);
    });
  }

  numberAttributeSelected():boolean {
    return this.attribute !== null && this.attribute.isNumber();
  }

  addRulesForValues(values:Array<any>) {
    this.valuesToAdd = values;
    console.log(this.valuesToAdd);
    if (this.layer.complexStyle && this.layer.complexStyle.styleRules.length > 0) {
      this.showMsgExistingRules = true;
    } else {
      this.finalizeAddRulesForValues();
    }
  }

  finalizeAddRulesForValues() {
    this.showMsgExistingRules = false;
    const values = this.valuesToAdd;
    for (let i = 0; i < values.length; i += 1) {
      const style = new LayerStyle();
      style.setBaseStyle(this.layer.style);
      if (this.modePointSize) {
        const range = this.maxPointSize - this.minPointSize;
        const interval = Math.floor(range / values.length);
        style.pointSymbol.size = this.minPointSize + i * interval;
      } else {
        const color:any = this.colorPalette?.getColorValue(i, this.nbColors); // .values[i % this.colorPalette?.values.length];
        style.applyRuleColor(color);
      }

      let filter = '';
      let label = '';
      if (this.analyseType === 'graduated') {
        filter = `${this.attribute?.name}>=${values[i].min} and ${this.attribute?.name}<${values[i].max}`;
        if (i === values.length - 1) {
          filter = `${this.attribute?.name}>=${values[i].min} and ${this.attribute?.name}<=${values[i].max}`;
        }
        label = `${this.attribute?.name} entre ${values[i].min} et ${values[i].max}`;
      } else {
        if (values[i].indexOf("'") > 0) {
          const replaceValue = values[i].replace(new RegExp('\'', 'g'), '*');
          filter = `${this.attribute?.name} like '${replaceValue}'`;
        } else {
          filter = `${this.attribute?.name}='${values[i]}'`;
        }

        label = values[i];
      }
      const newRule = new StyleRule({ label, value: filter, style });
      newRule.style = style;
      if (this.layer.complexStyle.styleRules.find((x) => x.value === filter) === undefined) {
        this.layer.complexStyle.styleRules.push(newRule);
      }
    }
    this.valuesToAdd = [];
  }
}
</script>

<style scoped lang="less">
@import "../../../styles/variables.less";

.rule_row:nth-child(even){
  background-color: fade(@first,10%);
}
.rule-list{
  box-shadow:0 1px 3px rgba(0, 0, 0, 0.12), 0 -1px 5px rgba(0, 0, 0, 0.24);
}
</style>
